# The MIT License (MIT)
# Copyright (c) 2016 Nelo-T. wallus <nelo@wallus.de>

# goscript::build builds a .go file on a node.
define goscript::build (
    String $file = $name,

    String $owner   = 'root',
    String $group   = 'root',
    Goscript::Mode $binmode = '0755',

    Goscript::Path $path = [
        '/usr/local/bin',
        '/usr/bin',
        '/bin',
    ],
) {

    $_target = "${file}.go"
    $_bin = $file

    exec { "go build ${_target}":
        path        => $path,
        subscribe   => File[$_target],
        refreshonly => true,
    } ->

    file { $_bin:
        owner => $owner,
        group => $group,
        mode  => $binmode,
    }

}
