# The MIT License (MIT)
# Copyright (c) 2016 Nelo-T. wallus <nelo@wallus.de>

# The goscript resource manages the file and goscript::build resources
# for a given golang file.
define goscript (
    String $file = $name,

    String $owner   = 'root',
    String $group   = 'root',

    Goscript::Mode $mode    = '0644',
    Goscript::Mode $binmode = '0755',

    Optional[String] $content = undef,
    Optional[String] $source = undef,
) {

    file { "${file}.go":
        ensure  => file,
        owner   => $owner,
        group   => $group,
        mode    => $mode,
        content => $content,
        source  => $source,
    }

    goscript::build { $file:
        binmode => $binmode,
    }

}
