# The MIT License (MIT)
# Copyright (c) 2016 Nelo-T. wallus <nelo@wallus.de>

# goscript::run executes a .go file on the node
define goscript::run (
    String $file = $name,

    Goscript::Path $path = [
        '/usr/local/bin',
        '/usr/bin',
        '/bin',
    ],

    # A given go file might already exist on the remote, e.g. installed
    # from a a package. In those cases the file should not be managed by
    # puppet.
    Boolean $requires = true,
) {

    $_require = $requires ? {
        true  => File[$file],
        false => undef,
    }

    exec { "go run ${file}":
        command => "go run ${file}",
        path    => $path,
        require => $_require,
    }

}
