require 'spec_helper'

describe 'goscript::build' do
    let(:title) { '/bin/test' }

    it do
        is_expected.to contain_exec('go build /bin/test.go').with({
            'path'        => '/usr/local/bin:/usr/bin:/bin',
            'refreshonly' => true,
        })

        is_expected.to contain_file('/bin/test').with({
            'owner' => 'root',
            'group' => 'root',
            'mode'  => '0755',
        })
    end

    context 'with path => /usr/bin' do
        let(:params) {
            {
                :path => '/usr/bin',
            }
        }

        it do
            is_expected.to contain_exec('go build /bin/test.go').with({
                'path'        => '/usr/bin',
                'refreshonly' => true,
            })
        end
    end

end
